CMac (Bouncy Castle Library 1.52 API Specification)

org.bouncycastle.crypto.macs

## Class CMac

- java.lang.Object
- - org.bouncycastle.crypto.macs.CMac

- All Implemented Interfaces:
    Mac
  Direct Known Subclasses:
    CMacWithIV

      public class CMac
      extends java.lang.Object
      implements Mac

  CMAC - as specified at www.nuee.nagoya-u.ac.jp/labs/tiwata/omac/omac.html

  CMAC is analogous to OMAC1 - see also en.wikipedia.org/wiki/CMAC

  CMAC is a NIST recomendation - see csrc.nist.gov/CryptoToolkit/modes/800-38_Series_Publications/SP800-38B.pdf

  CMAC/OMAC1 is a blockcipher-based message authentication code designed and analyzed by Tetsu Iwata and Kaoru Kurosawa.

  CMAC/OMAC1 is a simple variant of the CBC MAC (Cipher Block Chaining Message Authentication Code). OMAC stands for One-Key CBC MAC.

  It supports 128- or 64-bits block ciphers, with any key size, and returns a MAC with dimension less or equal to the block size of the underlying cipher.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CMac(BlockCipher cipher)` create a standard MAC based on a CBC block cipher (64 or 128 bit block).
    `CMac(BlockCipher cipher, int macSizeInBits)` create a standard MAC based on a block cipher with the size of the MAC been given in bits.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Compute the final stage of the MAC writing the output to the out parameter.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
    `int` | `getMacSize()` Return the block size for this MAC (in bytes).
    `void` | `init(CipherParameters params)` Initialise the MAC.
    `void` | `reset()` Reset the mac generator.
    `void` | `update(byte in)` add a single byte to the mac for processing.
    `void` | `update(byte[] in, int inOff, int len)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CMac

          public CMac(BlockCipher cipher)

      create a standard MAC based on a CBC block cipher (64 or 128 bit block). This will produce an authentication code the length of the block size of the cipher.
      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.

    - #### CMac

          public CMac(BlockCipher cipher,
              int macSizeInBits)

      create a standard MAC based on a block cipher with the size of the MAC been given in bits.

      Note: the size of the MAC must be at least 24 bits (FIPS Publication 81), or 16 bits if being used as a data authenticator (FIPS Publication 113), and in general should be less than the size of the block cipher as it reduces the chance of an exhaustive attack (see Handbook of Applied Cryptography).

      Parameters:
        `cipher` - the cipher to be used as the basis of the MAC generation.
        `macSizeInBits` - the size of the MAC in bits, must be a multiple of 8 and <= 128.

  - ### Method Detail

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Mac`
      Return the name of the algorithm the MAC implements.
      Specified by:
        `getAlgorithmName` in interface `Mac`
      Returns:
        the name of the algorithm the MAC implements.

    - #### init

          public void init(CipherParameters params)

      Description copied from interface: `Mac`
      Initialise the MAC.
      Specified by:
        `init` in interface `Mac`
      Parameters:
        `params` - the key and other data required by the MAC.

    - #### getMacSize

          public int getMacSize()

      Description copied from interface: `Mac`
      Return the block size for this MAC (in bytes).
      Specified by:
        `getMacSize` in interface `Mac`
      Returns:
        the block size for this MAC in bytes.

    - #### update

          public void update(byte in)

      Description copied from interface: `Mac`
      add a single byte to the mac for processing.
      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the byte to be processed.

    - #### update

          public void update(byte[] in,
                    int inOff,
                    int len)

      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the array containing the input.
        `inOff` - the index in the array the data begins at.
        `len` - the length of the input starting at inOff.

    - #### doFinal

          public int doFinal(byte[] out,
                    int outOff)

      Description copied from interface: `Mac`
      Compute the final stage of the MAC writing the output to the out parameter.

      doFinal leaves the MAC in the same state it was after the last init.

      Specified by:
        `doFinal` in interface `Mac`
      Parameters:
        `out` - the array the MAC is to be output to.
        `outOff` - the offset into the out buffer the output is to start at.

    - #### reset

          public void reset()

      Reset the mac generator.
      Specified by:
        `reset` in interface `Mac`